package com.yaohun.cardbackpack.config;

import com.yaohun.cardbackpack.AuCardBackpack;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.data.GuiItemData;
import me.Demon.DemonPlugin.data.LangData;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.util.HashMap;

public class Config {

    public static LangData langData;
    private static HashMap<String, GuiItemData> guiItemDataMap = new HashMap<>();

    public static void reloadConfig() {
        langData = DemonAPI.getLangData("AuCardBackpack");
        guiItemDataMap.clear();
        loadGuiItemData();
    }

    private static void loadGuiItemData(){
        File file = new File("plugins/AuSettings","AuCardBackpack.yml");
        FileConfiguration configuration = YamlConfiguration.loadConfiguration(file);
        ConfigurationSection section = configuration.getConfigurationSection("GuiItemData");
        if(section == null){return;}
        for (String itemKey : section.getKeys(false)){
            guiItemDataMap.put(itemKey,new GuiItemData(itemKey,section));
        }
    }

    public static ItemStack getItemStack(String itemKey) {
        if(guiItemDataMap.containsKey(itemKey)){
            return guiItemDataMap.get(itemKey).getItemStack();
        }
        return DemonAPI.getErrItems();
    }


}
