package com.yaohun.cardbackpack.data;

import de.tr7zw.itemnbtapi.NBTItem;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

public class PlayerData {

    private String name;
    public HashMap<Integer, ItemStack> itemStackHashMap;
    private File file;
    private FileConfiguration configuration;

    public PlayerData(String name) {
        this.name = name;
        this.file = new File("plugins/AuData/BackpackCard", name + ".yml");
        this.configuration = YamlConfiguration.loadConfiguration(this.file);
        this.itemStackHashMap = new HashMap<>();
        ConfigurationSection section = this.configuration.getConfigurationSection("Unlock-Slot");
        if(section != null) {
            for (String slotKey : section.getKeys(false)) {
                int slot = Integer.parseInt(slotKey);
                ItemStack itemStack = section.getItemStack(slotKey);
                itemStackHashMap.put(slot, itemStack);
            }
        }
    }

    public void SavePlayerData() {
        configuration.set("Unlock-Slot",null);
        for (Integer key : itemStackHashMap.keySet()) {
            ItemStack itemStack = itemStackHashMap.get(key);
            configuration.set("Unlock-Slot."+key, itemStack);
        }
        try {
            this.configuration.save(this.file);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public boolean isCardYearsExit(String hunkaKey){
        for (ItemStack itemStack : itemStackHashMap.values()) {
            NBTItem nbtItem = new NBTItem(itemStack);
            if(nbtItem.hasKey("hunkaKey")){
                if(nbtItem.getString("hunkaKey").equals(hunkaKey)){
                    return true;
                }
            }
        }
        return false;
    }
}
