package com.yaohun.cardbackpack.gui;

import com.yaohun.cardbackpack.AuCardBackpack;
import com.yaohun.cardbackpack.config.Config;
import com.yaohun.cardbackpack.data.PlayerData;
import com.yaohun.cardbackpack.manage.DataManager;
import com.yaohun.cardbackpack.util.StackUtil;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.Util.CDTimeAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.serverct.ersha.jd.AttributeAPI;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class CardGui implements Listener {

    private static String invTitle;

    public CardGui() {
        invTitle = Config.langData.getMessage("Gui-Title");
    }

    public static void OpenGui(Player player){
        String playerName = player.getName();
        DataManager dataManager = AuCardBackpack.getDataManager();
        PlayerData playerData = dataManager.getPlayerData(playerName);
        Inventory inv = Bukkit.createInventory(null,27,invTitle);
        inv.setItem(0, DemonAPI.glass(11,"§r"));
        inv.setItem(8, DemonAPI.glass(11,"§r"));
        for (int i = 9; i < 27;i++){
            inv.setItem(i,DemonAPI.glass(15,"§r"));
        }
        inv.setItem(21, DemonAPI.glass(15,"§r"));
        inv.setItem(22,DemonAPI.glass(0,"§7[§6魂卡背包§7]"));
        inv.setItem(23, DemonAPI.glass(15,"§r"));
        for (int i : new int[]{18,19,20,24,25,26}) {
            inv.setItem(i,DemonAPI.glass(0,"§7[§6魂卡背包§7]"));
        }
        inv.setItem(1,StackUtil.iconHide("§f十年魂卡槽"));
        inv.setItem(2,StackUtil.iconHide("§e百年魂卡槽"));
        inv.setItem(3,StackUtil.iconHide("§d千年魂卡槽"));
        inv.setItem(4,StackUtil.iconHide("§7万年魂卡槽"));
        inv.setItem(5,StackUtil.iconHide("§c十万年魂卡槽"));
        inv.setItem(6,StackUtil.iconHide("§r"));
        inv.setItem(7,StackUtil.iconHide("§r"));
        // 设置已穿戴的魂卡
        HashMap<Integer, ItemStack> stackHashMap = playerData.itemStackHashMap;
        for (Integer slot : stackHashMap.keySet()) {
            if (stackHashMap.get(slot) != null) {
                ItemStack stack = stackHashMap.get(slot).clone();
                if (!DemonAPI.itemIsNull(stack) && !DemonAPI.itemIsLore(stack)) {
                    ItemMeta meta = stack.getItemMeta();
                    meta.setDisplayName(meta.getDisplayName() + " §c§l[点击取出]");
                    stack.setItemMeta(meta);
                    inv.setItem(slot, stack);
                }
            }
        }
        player.openInventory(inv);
    }

    @EventHandler
    public void onClick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Player player = (Player) e.getWhoClicked();
        String playerName = player.getName();
        Inventory inventory = e.getInventory();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            if(rawSlot >= 0 && rawSlot < inventory.getSize()){
                e.setCancelled(true);
                // 获取点击的物品
                ItemStack click = e.getCurrentItem();
                // 判断点击的物品是否是卡牌槽
                if(rawSlot == 1 || rawSlot == 2 || rawSlot == 3 ||
                rawSlot == 4 || rawSlot == 5 || rawSlot == 6 || rawSlot == 7){
                    if(DemonAPI.itemIsNull(click))return;
                    DataManager dataManager = AuCardBackpack.getDataManager();
                    PlayerData playerData = dataManager.getPlayerData(playerName);
                    // 若点击此处并非空白则将物品返还给玩家
                    if(!click.getType().equals(Material.BARRIER)) {
                        if(!DemonAPI.itemIsLore(click)) {
                            ItemStack itemStack = playerData.itemStackHashMap.get(rawSlot);
                            player.getInventory().addItem(itemStack);
                            playerData.itemStackHashMap.remove(rawSlot);
                            inventory.setItem(rawSlot, StackUtil.iconHide("§c§l请放入魂卡"));
                            player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                            // 玩家取出这个卡牌后1分钟内肯定会打算吸一个更厉害的魂卡
                            CDTimeAPI.setPlayerCD(player.getUniqueId(),"cardback_fetch",1000L * 60);
                        }
                        return;
                    }
                    // 获取鼠标上的物品
                    ItemStack cursor = e.getCursor();
                    if(!DemonAPI.itemIsNull(cursor)){
                        NBTItem nbtItem = new NBTItem(cursor);
                        if(nbtItem.hasKey("hunkaKey")){
                            String hunkaKey = nbtItem.getString("hunkaKey");
                            if(playerData.isCardYearsExit(hunkaKey)){
                                AuCardBackpack.sendMessage(player,Config.langData.getMessage("quantityLimit"),Sound.ENTITY_VILLAGER_NO);
                                return;
                            }
                            e.setCursor(new ItemStack(Material.AIR));
                            ConfirmGui.OpenGui(player,cursor,hunkaKey);
                            // 打开一个新的窗口
                            player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1,1);
                        } else {
                            AuCardBackpack.sendMessage(player,Config.langData.getMessage("typeLimitations"),Sound.ENTITY_VILLAGER_NO);
                        }
                    }
                }
            }
        }
    }

    @EventHandler
    public void onClose(InventoryCloseEvent e){
        Player player = (Player) e.getPlayer();
        String playerName = player.getName();
        Inventory inventory = e.getInventory();
        if(e.getView().getTitle().equalsIgnoreCase(invTitle)){
            String attSource = "cardAttribute";
            AttributeAPI.deleteAttribute(player,attSource);
            List<String> statsList = new ArrayList<>();
            PlayerData playerData = AuCardBackpack.getDataManager().getPlayerData(playerName);
            for (int i : new int[]{0,1,2,3,4,5,6,7}){
                ItemStack stack = inventory.getItem(i);
                if(!DemonAPI.itemIsNull(stack)){
                    NBTItem nbtItem = new NBTItem(stack);
                    if(nbtItem.hasKey("hunkaKey")){
                        ItemMeta meta = stack.getItemMeta();
                        List<String> lore = meta.getLore();
                        for (int l = 0; l < lore.size(); l++) {
                            String s = lore.get(l);
                            if(s.contains("繫") || s.contains("龖") || s.contains("儁")){
                                statsList.add(s);
                            }
                            if(s.contains("鬻 §7物品绑定: §e使用后绑定")){
                                lore.set(l,"鬻 §7物品已绑定: §e"+playerName);
                                meta.setLore(lore);
                                stack.setItemMeta(meta);
                                playerData.itemStackHashMap.put(i,stack);
                            }
                        }
                    }
                }
            }
            AttributeAPI.addAttribute(player, attSource, statsList);
        }
    }
}
