package com.yaohun.cardbackpack.gui;

import com.yaohun.cardbackpack.AuCardBackpack;
import com.yaohun.cardbackpack.config.Config;
import com.yaohun.cardbackpack.data.CardData;
import com.yaohun.cardbackpack.data.PlayerData;
import com.yaohun.cardbackpack.manage.DataManager;
import com.yaohun.cardbackpack.util.StackUtil;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.Util.CDTimeAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class ConfirmGui implements Listener {

    private static String invTitle;
    private static String startTitle;

    public ConfirmGui() {
        invTitle = Config.langData.getMessage("Confiirm-Title");
        startTitle = invTitle.split("%s")[0];
    }

    public static void OpenGui(Player player, ItemStack cardStack,String hunkaKey){
        DataManager dataManager = AuCardBackpack.getDataManager();
        CardData cardData = dataManager.getCardData(hunkaKey);
        if(cardData == null){
            player.closeInventory();
            player.getInventory().addItem(cardStack);
            return;
        }
        String itemName = cardStack.getItemMeta().getDisplayName();
        Inventory inv = Bukkit.createInventory(null,9,invTitle.replace("%s",itemName));
        inv.setItem(1,cardStack);
        inv.setItem(6, StackUtil.confirmStack(cardData));
        inv.setItem(8, Config.getItemStack("backStack"));
        player.openInventory(inv);
    }

    @EventHandler
    public void onClick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Player player = (Player) e.getWhoClicked();
        String playerName = player.getName();
        Inventory inventory = e.getInventory();
        if (e.getView().getTitle().contains(startTitle)) {
            e.setCancelled(true);
            if(rawSlot == 8){
                CardGui.OpenGui(player);
            }
            if(rawSlot == 6){
                ItemStack item = e.getCurrentItem();
                NBTItem nbtItem = new NBTItem(item);
                if(nbtItem.hasKey("hunka")){
                    String hunkaKey = nbtItem.getString("hunka");
                    CardData cardData = AuCardBackpack.getDataManager().getCardData(hunkaKey);
                    if(cardData == null){
                        return;
                    }
                    // 判断金币
                    int needMoney = cardData.needMoney;
                    if(!DemonAPI.hasMoney(player, needMoney)){
                        CardGui.OpenGui(player);
                        String message = Config.langData.getMessage("moneyNotEnough");
                        AuCardBackpack.sendMessage(player,message.replace("%money%",DemonAPI.MoneyFormat(needMoney)),Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    int addRandom = 0;
                    if(CDTimeAPI.isCD(player.getUniqueId(),"cardback_fetch")){
                        addRandom = 100;
                    }
                    if(cardData.isChance(addRandom)){
                        int slot = cardData.getCardSlot();
                        PlayerData playerData = AuCardBackpack.getDataManager().getPlayerData(playerName);
                        ItemStack stack = inventory.getItem(1);
                        playerData.itemStackHashMap.put(slot,stack);
                        inventory.setItem(1,new ItemStack(Material.AIR));
                        CardGui.OpenGui(player);
                        String message = Config.langData.getMessage("successfullyInhaled");
                        String itemName = stack.getItemMeta().getDisplayName();
                        AuCardBackpack.sendMessage(player,message.replace("%itemName%",itemName),Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    } else {
                        inventory.setItem(1,new ItemStack(Material.AIR));
                        player.closeInventory();
                        CardGui.OpenGui(player);
                        String message = Config.langData.getMessage("probabilityFailure");
                        AuCardBackpack.sendMessage(player,message,Sound.ENTITY_VILLAGER_NO);
                    }
                }
            }
        }
    }

    @EventHandler
    public void onClose(InventoryCloseEvent e) {
        Player player = (Player) e.getPlayer();
        String playerName = player.getName();
        Inventory inventory = e.getInventory();
        if (e.getView().getTitle().contains(startTitle)) {
            ItemStack itemStack = inventory.getItem(1);
            if(!DemonAPI.itemIsNull(itemStack) && !DemonAPI.itemIsLore(itemStack)){
                player.getInventory().addItem(itemStack);
            }
        }
    }
}
