package com.yaohun.cardbackpack.listener;

import com.io.yaohun.itemlibrary.api.ItemKuAPI;
import com.yaohun.cardbackpack.util.RandomUtil;
import me.Demon.DemonMmKillsDrop.data.DropLogsData;
import me.Demon.DemonMmKillsDrop.manage.LogsManager;
import me.Demon.DemonMmKillsStats.Event.KillsMobsStatsEvent;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.serverct.ersha.jd.Ha;

import java.util.HashMap;

public class KillMobsListener implements Listener {

    private static HashMap<String,Double> mobLuckyValue = new HashMap<>();

    private static double getLuckyValue(String mobsType) {
        if(!mobLuckyValue.containsKey(mobsType)) {
            return 0.0D;
        }
        return mobLuckyValue.get(mobsType);
    }

    private static void addLuckyValue(String mobsType, double luckyValue) {
        double nowValue = getLuckyValue(mobsType);
        if(!mobLuckyValue.containsKey(mobsType)) {
            mobLuckyValue.put(mobsType, nowValue + luckyValue);
        }
        mobLuckyValue.put(mobsType, nowValue + luckyValue);
    }

    @EventHandler
    public void onkills(KillsMobsStatsEvent e) {
        Player player = e.getPlayer();
        String mobType = e.getMob_type();
        double luckyValue = getLuckyValue(mobType);
        double randomChance = RandomUtil.getRandomDouble(0.1D,300.0D,2);
        if(luckyValue > randomChance) {
            ItemStack stack = getCardStack(mobType);
            if(!DemonAPI.itemIsNull(stack)) {
                player.getInventory().addItem(stack);
            }
            mobLuckyValue.put(mobType,0.0D); // 清空幸运值
        } else {
            addLuckyValue(mobType, RandomUtil.getRandomDouble(0.1,1.0,1));
        }
    }

    public ItemStack getCardStack(String mobsType) {
        String itemKey = null;
        if(mobsType.contains("百年")){
            itemKey = "百年魂卡";
        }else if(mobsType.contains("千年")){
            itemKey = "千年魂卡";
        }else if(mobsType.contains("万年")){
            itemKey = "万年魂卡";
        }else if(mobsType.contains("十年")){
            itemKey = "十年魂卡";
        }
        if(itemKey != null) {
            LogsManager logsManager = me.Demon.DemonMmKillsDrop.Main.getDataManager().getLogsManager();
            DropLogsData dropLogsData = logsManager.addDropLogsDataMap(mobsType);
            dropLogsData.addDropKeyAmount(itemKey);
            return ItemKuAPI.getItemSystemNoLog(itemKey);
        } else {
            return null;
        }
    }
}
