package com.yaohun.cardbackpack.manage;

import com.yaohun.cardbackpack.config.Config;
import com.yaohun.cardbackpack.data.CardData;
import com.yaohun.cardbackpack.data.PlayerData;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.serverct.ersha.jd.Ha;

import java.io.File;
import java.util.HashMap;

public class DataManager {

    private HashMap<String, CardData> cardDataMap = new HashMap<>();
    private HashMap<String, PlayerData> playerDataMap = new HashMap<>();


    public DataManager(){
        loadCardData();
    }

    public void reloadDataManager(){
        SaveAllPlayerData();
        playerDataMap.clear();
        cardDataMap.clear();
        loadCardData();
        Config.reloadConfig();
    }

    public void loadCardData(){
        File file = new File("plugins/AuSettings","AuCardBackpack.yml");
        FileConfiguration configuration = YamlConfiguration.loadConfiguration(file);
        ConfigurationSection section = configuration.getConfigurationSection("CardData");
        if(section != null){
            for (String hunkaKey : section.getKeys(false)){
                int slot = section.getInt(hunkaKey+".slot");
                int money = section.getInt(hunkaKey+".money");
                double chance = section.getDouble(hunkaKey+".chance");
                this.cardDataMap.put(hunkaKey,new CardData(hunkaKey,slot,money,chance));
            }
        }
    }

    public void SaveAllPlayerData(){
        for (PlayerData playerData : playerDataMap.values()) {
            playerData.SavePlayerData();
        }
    }

    public PlayerData getPlayerData(String playerName){
        if(!this.playerDataMap.containsKey(playerName)){
            this.playerDataMap.put(playerName, new PlayerData(playerName));
        }
        return this.playerDataMap.get(playerName);
    }

    public CardData getCardData(String hunkaKey){
        if(this.cardDataMap.containsKey(hunkaKey)){
           return this.cardDataMap.get(hunkaKey);
        }
        return null;
    }
}
