package com.yaohun.cardbackpack.util;

import com.yaohun.cardbackpack.AuCardBackpack;
import com.yaohun.cardbackpack.config.Config;
import com.yaohun.cardbackpack.data.CardData;
import com.yaohun.cardbackpack.manage.DataManager;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class StackUtil {

    public static ItemStack iconHide(String name){
        ItemStack stack = Config.getItemStack("iconHide").clone();
        ItemMeta meta = stack.getItemMeta();
        meta.setDisplayName(name);
        stack.setItemMeta(meta);
        NBTItem nbtItem = new NBTItem(stack);
        nbtItem.setString("icon","hide");
        nbtItem.setString("stex","icon_air");
        return nbtItem.getItem();
    }

    public static ItemStack confirmStack(CardData cardData){
        ItemStack stack = Config.getItemStack("confirmStack").clone();
        ItemMeta meta = stack.getItemMeta();
        List<String> lore = meta.getLore();
        for (int i = 0; i < lore.size(); i++){
            String string = lore.get(i);
            if(string.contains("{chance}")){
                string = string.replace("{chance}",String.valueOf(cardData.chance));
            }
            if(string.contains("{money}")){
                string = string.replace("{money}", DemonAPI.MoneyFormat(cardData.needMoney));
            }
            lore.set(i, string);
        }
        meta.setLore(lore);
        stack.setItemMeta(meta);
        NBTItem nbtItem = new NBTItem(stack);
        nbtItem.setString("hunka",cardData.getCardKey());
        return nbtItem.getItem();
    }
}
